OnlineShop/urls.py
from django.conf.urls.i18n import i18n_patterns
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from app.accounts.views import LogoutView

urlpatterns = [
    path('admin/logout/', LogoutView.as_view(), name='logout'),
    path('admin/', admin.site.urls),
    path("__debug__/", include("debug_toolbar.urls")),
    path('ckeditor/', include('ckeditor_uploader.urls')),
] + i18n_patterns(
    path('i18n/', include('django.conf.urls.i18n')),
    path('', include('app.products.urls')),
    path('users/', include("app.accounts.urls")),
    path('order/', include('app.order.urls')),
)

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

app/accounts/urls.py
from django.urls import path
from .views import LoginView, LogoutView, RegisterView, ProfileView, ProfileUpdateView, PasswordChangeView, OrderDetailView, user_info


app_name = 'accounts'
urlpatterns = [
    path("register/", RegisterView.as_view(), name="register"),
    path("login/", LoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(), name="logout"),
    path("profile/", ProfileView.as_view(), name="profile"),
    path('order-detail/<uuid:uuid>/', OrderDetailView.as_view(), name='order_detail'),
    path("profile/edit/", ProfileUpdateView.as_view(), name="profile-edit"),
    path('password-change/', PasswordChangeView.as_view(), name='password_change'),
    path('admin-info/',user_info, name='admin_info')
]

app/order/urls.py
from django.urls import path
from .views import WithListView, WithListUuidView, WishListDeleteView, ShopCartListView, ShopCartDeleteView, ShopCartDeleteAllView, \
    ShopCartAddOneView, OrderCreateView, OrderCreateOneClikView, OrderVariantView,\
     OrderCreateInfoView, NotificationView, OrderInfoDeleteView

app_name = 'order'
urlpatterns = [
    path('wishlist/<uuid:uuid>/', WithListUuidView.as_view(), name='wishlist_product'),
    path('wishlist/', WithListView.as_view(), name='wishlist'),
    path('wishlist/<uuid:uuid>/delete/', WishListDeleteView.as_view(), name='wishlist_delete'),
    path('shop-cart-list/', ShopCartListView.as_view(), name='shop_cat_list'),
    path('shop-cart/<uuid:uuid>/delete/', ShopCartDeleteView.as_view(), name='shop_cart_delete'),
    path('shop-delete-all/', ShopCartDeleteAllView.as_view(), name='shop_delete_all'),
    path('shop-cart/<uuid:uuid>/', ShopCartAddOneView.as_view(), name='shop_cart_product'),
    path('order-create/', OrderCreateView.as_view(), name='order_create'),
    path('order-create-one-click/<uuid:uuid>/', OrderCreateOneClikView.as_view(), name='order_create_one_click'),
    path('order-create-info/<uuid:uuid>/', OrderCreateInfoView.as_view(), name='order_create_info'),
    path('order-create-variant/<uuid:uuid>/', OrderVariantView.as_view(), name='order_create_variant'),
    path('notification/', NotificationView.as_view(), name='notification'),
    path('order_info_delete/<uuid:uuid>/delete/', OrderInfoDeleteView.as_view(), name='order_info_delete'),


]

app/products/urls.py
from django.urls import path
from .views import HomePage, ShopView, ShopViewAll, ShopDetailView, ProductCommentView, SearchResultsView, OrgShopView

app_name = 'products'
urlpatterns = [
    path('', HomePage.as_view(), name='home'),
    path('shop/', ShopViewAll.as_view(), name='shop'),
    path('shop/<uuid:uuid>/', ShopView.as_view(), name='shop'),
    path('product/<slug:slug>/<uuid:uuidd>/', ShopDetailView.as_view(), name='shop_detail'),
    path('comment/<uuid:uuid>/', ProductCommentView.as_view(), name='comment_create'),
    path('search/', SearchResultsView.as_view(), name='search'),
    path('org/<uuid:uuid>', OrgShopView.as_view(), name='org')
]

app/base/models.py
from django.db import models
from django.utils import timezone
import datetime
import uuid 
from mptt.models import MPTTModel, TreeForeignKey
# Create your models here.
class BaseModel(models.Model):
    uuid = models.UUIDField(default = uuid.uuid4, 
         editable = False)
    create_at = models.DateTimeField(auto_now_add=True)
    update_at = models.DateTimeField(auto_now=True)

    class Meta:
        abstract = True


class Variant(MPTTModel, BaseModel):
    name = models.CharField(max_length=255, null=True, blank=True)
    parent = TreeForeignKey('self', on_delete=models.CASCADE, null=True, blank=True, related_name='children')
    description = models.TextField(null=True, blank=True)
    duration = models.IntegerField(default=0)
    percent = models.IntegerField(default=0)
    is_active = models.BooleanField(default=True)
    
    def __str__(self) -> str:
        return self.description

app/base/views.py
from django.shortcuts import render

# Create your views here.

templates/shop-cart.html
{% extends 'base.html' %}
{% load humanize %}
{% load django_template_maths %}
{% load i18n %}

{% block content %}
    <main class="main">
        <div class="page-header breadcrumb-wrap">
            <div class="container">
                <div class="breadcrumb">
                    <a href="index.html" rel="nofollow">{% blocktranslate %} Bosh Sahifa {% endblocktranslate %}</a>
                
                    <span></span> {% blocktranslate %} Savatchangiz {% endblocktranslate %}
                </div>
            </div>
        </div>
        <section class="mt-60 mb-60">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div class="table-responsive">
                            <table class="table shopping-summery text-center clean">
                                <thead>
                                    <tr class="main-heading">
                                        <th scope="col">{% blocktranslate %} Rasm {% endblocktranslate %}</th>
                                        <th scope="col">{% blocktranslate %} Mahsulot {% endblocktranslate %}</th>
                                        <th scope="col">{% blocktranslate %} Narx {% endblocktranslate %}</th>
                                        <th scope="col">{% blocktranslate %} Rang {% endblocktranslate %}</th>
                                        <th scope="col">{% blocktranslate %} O'lcham {% endblocktranslate %}</th>
                                        <th scope="col">{% blocktranslate %} Soni {% endblocktranslate %}</th>
                                        <th scope="col">{% blocktranslate %} Jami {% endblocktranslate %}</th>
                                        <th scope="col">{% blocktranslate %} O'chirish {% endblocktranslate %}</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    {% for shopcart in shopcart %}
                                        <tr>
                                            {% if shopcart.product.product_images.first.image.url %}
                                                <td class="image product-thumbnail"><img src="{{ shopcart.product_image.image.url }}" alt="#"></td>
                                            {% endif %}
                                            <td class="product-des product-name">
                                                <p class="product-name"><a href="{% url 'products:shop_detail' shopcart.product.slug shopcart.product.uuid %}">{{ shopcart.product.title }}</a></p>
                                                <p class="font-xs">{{ shopcart.product.desc|slice:100|safe }}
                                                </p>
                                            </td>
                                            <td class="price" data-title="Price">
                                                
                                                <span class="text-brand">{{ shopcart.product_price|floatformat:0|intcomma }} {% blocktranslate %} so'm {% endblocktranslate %}</span>
                                               
                                            </td>
                                            
                                            <td class="text-center" data-title="Color">
                                                    <span class="qty-val">{{ shopcart.product_color.name }}</span>                                               
                                            </td>
                                            <td class="text-center" data-title="Size">
                                                <span class="qty-val">{{ shopcart.product_size.name }}</span>                                               
                                            </td>
                                            <td class="text-center" data-title="Quantity">
                                                
                                                   
                                                    <span class="qty-val">{{ shopcart.quenty }} x</span>
                                               
                                            </td>
                                            <td class="text-right" data-title="Subtotal">
                                                <span>
                                                    {{ shopcart.product_price|mul:shopcart.quenty|floatformat:0|intcomma }}
                                                </span>
                                            </td>
                                            <td class="action" data-title="Remove"><a href="{% url 'order:shop_cart_delete' shopcart.uuid %}" class="text-muted"><i class="fa fa-trash-alt"></i></a></td>
                                        </tr>
                                    {% endfor %}
                                    
                                    <tr>
                                        {% if shopcart|length == 0 %}
                                        {% else %}
                                        <td colspan="6" class="text-end">
                                            <a href="{% url 'order:shop_delete_all' %}" class="text-muted"> <i class="fa fa-times-circle"></i> {% blocktranslate %} Savatchani tozalash {% endblocktranslate %}</a>
                                        </td>
                                        {% endif %}
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                        <div class="divider center_icon mt-50 mb-50"><i class="fa fa-gem"></i></div>
                        <div class="row mb-50">
                            
                            <div class="col-lg-12 col-md-12">
                                <div class="border p-md-4 p-30 border-radius-10 cart-totals">
                                    <div class="heading_s1 mb-3">
                                        <h4>{% blocktranslate %} Barcha mahsulotlar {% endblocktranslate %}</h4>
                                    </div>
                                    <div class="table-responsive">
                                        <table class="table">
                                            <tbody>
                                                {% for shopcart in shopcart %}
                                                    <tr>
                                                            <td class="cart_total_label">{{ shopcart.product.title }}</td>
                                                            <td class="cart_total_amount"><span class="font-lg fw-900 text-brand">
                                                            
                                                                {{ shopcart.product_price|mul:shopcart.quenty|floatformat:0|intcomma }}
                                                            </span></td>
                                                           
                                                    </tr>
                                                {% endfor %}
                                                <tr>
                                                    <td class="cart_total_label">{% blocktranslate %} Jami {% endblocktranslate %}</td>
                                                    <td class="cart_total_amount"><strong><span class="font-xl fw-900 text-brand">{{ all_price|intcomma }}</span></strong></td>
                                                </tr>
                                            </tbody>
                                        </table>
                                    </div>
                                    {% if shopcart|length == 0 %}
                                    {% else %}
                                        <a href="{% url "order:order_create" %}" class="btn btn-rounded"> <i class="fa fa-share-square mr-10"></i>{% blocktranslate %} Tasdiqlash {% endblocktranslate %}</a>
                                    {% endif %}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>
    </main>
{% endblock content %}
    

templates/shop-notifications.html
{% extends 'base.html' %}
{% load humanize %}
{% load i18n %}

{% block content %}
    <main class="main">
        <div class="page-header breadcrumb-wrap">
            <div class="container">
                <div class="breadcrumb">
                    <a href="index.html" rel="nofollow">{% blocktranslate %} Bosh Sahifa {% endblocktranslate %}</a>
                    <span></span> {% blocktranslate %} Bildirishnomalar {% endblocktranslate %}
                </div>
            </div>
        </div>
        <section class="mt-60 mb-60">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div class="table-responsive">
                            <table class="table shopping-summery text-center">
                                <thead>
                                    <tr class="main-heading">
                                        <th scope="col" colspan="2">{% blocktranslate %} Mahsulot {% endblocktranslate %}</th>
                                        <th scope="col">{% blocktranslate %} Sana {% endblocktranslate %}</th>
                                        <th scope="col">{% blocktranslate %} Harakat {% endblocktranslate %}</th>
                                        <th scope="col">{% blocktranslate %} O'chirish {% endblocktranslate %}</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    {% for order_info in order_info %}
                                        <tr>
                                            
                                            <td class="image product-thumbnail"><img src="{{ order_info.product.product_images.first.image.url }}" alt="#"></td>
                                            <td class="product-des product-name">
                                                <p class="product-name"><a href="{% url 'products:shop_detail' order_info.product.slug  order_info.product.uuid %}">{{ order_info.product.title }}</a></p>
                                                <p class="font-xs">{{ order_info.product.desc|safe|slice:100 }}
                                                </p>
                                            </td>
                                            <td>{{ order_info.create_at }}</td>

                                            <td class="text-right" data-title="Cart">
                                                <a href="{% url 'order:shop_cart_product' order_info.product.uuid %}" class="btn btn-rounded btn-sm"><i class="far fa-shopping-bag mr-5"></i>{% blocktranslate %} Savatchaga qo'shish {% endblocktranslate %}</a>
                                            </td>
                                            <td class="action" data-title="Remove"><a href="{% url 'order:order_info_delete' order_info.uuid  %}"><i class="fa fa-trash-alt"></i></a></td>
                                        </tr>
                                    {% endfor %}
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </section>
    </main>
{% endblock content %}

templates/shop-wishlist.html
{% extends 'base.html' %}
{% load humanize %}
{% load i18n %}

{% block content %}
    <main class="main">
        <div class="page-header breadcrumb-wrap">
            <div class="container">
                <div class="breadcrumb">
                    <a href="index.html" rel="nofollow">{% blocktranslate %} Bosh Sahifa {% endblocktranslate %}</a>
                 
                    <span></span> {% blocktranslate %} Xohishlar {% endblocktranslate %}
                </div>
            </div>
        </div>
        <section class="mt-60 mb-60">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div class="table-responsive">
                            <table class="table shopping-summery text-center">
                                <thead>
                                    <tr class="main-heading">
                                        <th scope="col" colspan="2">{% blocktranslate %} Mahsulot {% endblocktranslate %}</th>
                                        <th scope="col">{% blocktranslate %} Narx {% endblocktranslate %}</th>
                                        <th scope="col">{% blocktranslate %} Harakat {% endblocktranslate %}</th>
                                        <th scope="col">{% blocktranslate %} O'chirish {% endblocktranslate %}</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    {% for wishlist in wishlist %}
                                        <tr>
                                            
                                            <td class="image product-thumbnail"><img src="{{ wishlist.product.product_images.first.image.url }}" alt="#"></td>
                                            <td class="product-des product-name">
                                                <p class="product-name"><a href="{% url 'products:shop_detail' wishlist.product.slug  wishlist.product.uuid %}">{{ wishlist.product.title }}</a></p>
                                                <p class="font-xs">{{ wishlist.product.desc|safe|slice:100 }}
                                                </p>
                                            </td>
                                            <td class="price" data-title="Price">
                                                {% if wishlist.product.percentage %}
                                                    <span class="text-brand">{{ wishlist.product.get_discount_price|floatformat:0|intcomma }} {% blocktranslate %} so'm {% endblocktranslate %}</span>
                                                {% else %}
                                                    <span class="text-brand">{{ wishlist.product.get_price|floatformat:0|intcomma }} {% blocktranslate %} so'm {% endblocktranslate %}</span>
                                                {% endif %}
                                            </td>
                                            
                                            <td class="text-right" data-title="Cart">
                                                <a href="{% url 'order:shop_cart_product' wishlist.product.uuid %}" class="btn btn-rounded btn-sm"><i class="far fa-shopping-bag mr-5"></i>{% blocktranslate %} Savatchaga qo'shish {% endblocktranslate %}</a>
                                            </td>
                                            <td class="action" data-title="Remove"><a href="{% url 'order:wishlist_delete' wishlist.uuid  %}"><i class="fa fa-trash-alt"></i></a></td>
                                        </tr>
                                    {% endfor %}
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </section>
    </main>
{% endblock content %}

templates/shopall.html
{% extends 'base_shop_all.html' %}
{% load django_template_maths %}
{% load i18n %}

{% load humanize %}


    {% block content %}
    <main class="main">
        <div class="page-header breadcrumb-wrap">
            <div class="container">
                <div class="breadcrumb">
                    <a href="{% url 'products:home' %}" rel="nofollow">{% blocktranslate %} Bosh Sahifa {% endblocktranslate %}</a>
                    <span></span> <a href="{% url 'products:shop' %}">{% blocktranslate %} Barcha tavarlar {% endblocktranslate %}</a>
                </div>
            </div>
        </div>
        <section class="mt-60 mb-60">
            
            <div class="container">
                <div class="row flex-row-reverse">
                    <div class="col-lg-12">
                        <div class="shop-product-fillter">
                            <div class="totall-product">
                                <p> {% blocktranslate %} Biz siz uchun {% endblocktranslate %} <strong class="text-brand">{{ products|length }}</strong> {% blocktranslate %} ta mahsulot topdik{% endblocktranslate %}!</p>
                            </div>
                        </div>
                        <div class="row product-grid-4">
                            {% for product in products %}
                                <div class="col-lg-3 col-md-3 col-12 col-sm-6">
                                    <div class="product-cart-wrap mb-30">
                                        <div class="product-img-action-wrap">
                                            <div class="product-img product-img-zoom">
                                                <a href="{% url 'products:shop_detail' product.slug  product.uuid %}">
                                                    <img class="default-img" src="{{ product.product_images.first.image.url }}" alt="">
                                                    <img class="hover-img" src="{{ product.product_images.last.image.url }}" alt="">
                                                </a>
                                            </div>
                                            <div class="product-action-1">
                                                <a aria-label="{% blocktranslate %} Istaklar {% endblocktranslate %}" class="action-btn hover-up" href="{% url 'order:wishlist_product' product.uuid %}"><i class="far fa-heart"></i></a>
                                            </div>
                                            <div class="product-badges product-badges-position product-badges-mrg">
                                                <span class="{{ product.status }}">{% if product.status %}{{ product.status }}{% endif %}</span>
                                            </div>
                                        </div>
                                        <div class="product-content-wrap">
                                            <div class="product-category">
                                                {% if product.brand %}
                                                    <a href="#">{{ product.brand }}</a>
                                                {% else %}
                                                    <pre> </pre>
                                                {% endif %}
                                            </div>
                                            <h2 style="height: 50px;"><a href="{% url 'products:shop_detail' product.slug  product.uuid %}">{{ product.title|slice:":60" }}</a></h2>
                                            <div class="product-rate">
                                                <div class="product-rating"
                                                     style="width:{{ product.mid_stars_percent }}%"></div>
                                            </div>
                                            <div class="product-price">
                                                {% if product.percentage %}
                                            
                                                    <span class="old-price" >{{ product.get_price|floatformat:0|intcomma }} {% blocktranslate %} so'm {% endblocktranslate %}</span><br>
                                                    {% if product.variant.first.get_children.first %}
                                                    <span class="new-price">{{ product.get_discount_price|floatformat:0|intcomma }} {% blocktranslate %} so'm {% endblocktranslate %}</span><br>
                                                    
                                                    <span class="variant-price">{{ product.get_discount_price|mul:product.variant.first.get_children.first.percent|div:100|add:product.get_discount_price|div:product.variant.first.get_children.first.duration|floatformat:0|intcomma }} {% blocktranslate %} so'm {% endblocktranslate %}/oyiga</span>
                                                    {% else %}
                                        
                                                    <span class="variant-price">{{ product.get_discount_price|floatformat:0|intcomma }} {% blocktranslate %} so'm {% endblocktranslate %}</span><br>
                                                    {% endif %}

                                                {% else %}
                                                    {% if product.variant.first.get_children.first %}
                                                    <span class="new-price mt-30">{{ product.get_price|floatformat:0|intcomma }} {% blocktranslate %} so'm {% endblocktranslate %}</span><br>
                                                    
                                                    <span class="variant-price mt-30">{{ product.get_price|mul:product.variant.first.get_children.first.percent|div:100|add:product.get_price|div:product.variant.first.get_children.first.duration|floatformat:0|intcomma }} {% blocktranslate %} so'm {% endblocktranslate %}/oyiga</span>
                                                    {% else %}
                                                    <br>
                                                    <span class="variant-price">{{ product.get_price|floatformat:0|intcomma }} {% blocktranslate %} so'm {% endblocktranslate %}</span><br>
                                                    {% endif %}
                                                    <pre> </pre>
                                                {% endif %}
                                            </div>
                                            <div class="product-action-1 show">
                                                <a aria-label="{% blocktranslate %} Istaklar {% endblocktranslate %}" class="action-btn hover-up d-lg-none" href="{% url 'order:wishlist_product' product.uuid %}"><i class="far fa-heart"></i></a>

                                                <a aria-label="Savatchaga" class="action-btn hover-up" href="{% url 'order:shop_cart_product' product.uuid %}"><i class="far fa-shopping-bag"></i></a>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            {% endfor %}
                        </div>
                        <!--pagination-->
                        <div class="pagination-area mt-15 mb-md-5 mb-lg-0">
                            <nav aria-label="Page navigation example">
                                <ul class="pagination justify-content-start justify-content-center">
                                    {% if products.has_previous %}
                                        <li class="page-item"><a class="page-link" href="?page={{ products.previous_page_number }}"><i class="fa fa-angle-left"></i></a>
                                        </li>
                                    {% endif %}
                                    <li class="page-item active">
                                        <a href="#" class="page-link">{{ products.number }}</a>
                                    </li>
                                    {% if products.has_next %}
                                        <li class="page-item"><a class="page-link" href="?page={{ products.next_page_number }}"><i class="fa fa-angle-right"></i></a></li>

                                    {% endif %}

                                </ul>
                            </nav>
                        </div>
                    </div>
                </div>
            </div>
        </section>
    </main>
    
    {% endblock content %}